

# DisposePackageVersions
<a name="API_DisposePackageVersions"></a>

 Deletes the assets in package versions and sets the package versions' status to `Disposed`. A disposed package version cannot be restored in your repository because its assets are deleted. 

 To view all disposed package versions in a repository, use [ListPackageVersions](https://docs.aws.amazon.com/codeartifact/latest/APIReference/API_ListPackageVersions.html) and set the [status](https://docs.aws.amazon.com/codeartifact/latest/APIReference/API_ListPackageVersions.html#API_ListPackageVersions_RequestSyntax) parameter to `Disposed`. 

 To view information about a disposed package version, use [DescribePackageVersion](https://docs.aws.amazon.com/codeartifact/latest/APIReference/API_DescribePackageVersion.html). 

## Request Syntax
<a name="API_DisposePackageVersions_RequestSyntax"></a>

```
POST /v1/package/versions/dispose?domain=domain&domain-owner=domainOwner&format=format&namespace=namespace&package=package&repository=repository HTTP/1.1
Content-type: application/json

{
   "expectedStatus": "string",
   "versionRevisions": { 
      "string" : "string" 
   },
   "versions": [ "string" ]
}
```

## URI Request Parameters
<a name="API_DisposePackageVersions_RequestParameters"></a>

The request uses the following URI parameters.

 ** [domain](#API_DisposePackageVersions_RequestSyntax) **   <a name="codeartifact-DisposePackageVersions-request-uri-domain"></a>
 The name of the domain that contains the repository you want to dispose.   
Length Constraints: Minimum length of 2. Maximum length of 50.  
Pattern: `[a-z][a-z0-9\-]{0,48}[a-z0-9]`   
Required: Yes

 ** [domainOwner](#API_DisposePackageVersions_RequestSyntax) **   <a name="codeartifact-DisposePackageVersions-request-uri-domainOwner"></a>
 The 12-digit account number of the AWS account that owns the domain. It does not include dashes or spaces.   
Length Constraints: Fixed length of 12.  
Pattern: `[0-9]{12}` 

 ** [format](#API_DisposePackageVersions_RequestSyntax) **   <a name="codeartifact-DisposePackageVersions-request-uri-format"></a>
 A format that specifies the type of package versions you want to dispose.   
Valid Values: `npm | pypi | maven | nuget | generic | ruby | swift | cargo`   
Required: Yes

 ** [namespace](#API_DisposePackageVersions_RequestSyntax) **   <a name="codeartifact-DisposePackageVersions-request-uri-namespace"></a>
The namespace of the package versions to be disposed. The package component that specifies its namespace depends on its type. For example:  
The namespace is required when disposing package versions of the following formats:  
+ Maven
+ Swift
+ generic
+  The namespace of a Maven package version is its `groupId`. 
+  The namespace of an npm or Swift package version is its `scope`. 
+ The namespace of a generic package is its `namespace`.
+  Python, NuGet, Ruby, and Cargo package versions do not contain a corresponding component, package versions of those formats do not have a namespace. 
Length Constraints: Minimum length of 1. Maximum length of 255.  
Pattern: `[^#/\s]+` 

 ** [package](#API_DisposePackageVersions_RequestSyntax) **   <a name="codeartifact-DisposePackageVersions-request-uri-package"></a>
 The name of the package with the versions you want to dispose.   
Length Constraints: Minimum length of 1. Maximum length of 255.  
Pattern: `[^#/\s]+`   
Required: Yes

 ** [repository](#API_DisposePackageVersions_RequestSyntax) **   <a name="codeartifact-DisposePackageVersions-request-uri-repository"></a>
 The name of the repository that contains the package versions you want to dispose.   
Length Constraints: Minimum length of 2. Maximum length of 100.  
Pattern: `[A-Za-z0-9][A-Za-z0-9._\-]{1,99}`   
Required: Yes

## Request Body
<a name="API_DisposePackageVersions_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [expectedStatus](#API_DisposePackageVersions_RequestSyntax) **   <a name="codeartifact-DisposePackageVersions-request-expectedStatus"></a>
 The expected status of the package version to dispose.   
Type: String  
Valid Values: `Archived | Disposed | Published | Unfinished | Unlisted`   
Required: No

 ** [versionRevisions](#API_DisposePackageVersions_RequestSyntax) **   <a name="codeartifact-DisposePackageVersions-request-versionRevisions"></a>
 The revisions of the package versions you want to dispose.   
Type: String to string map  
Key Length Constraints: Minimum length of 1. Maximum length of 255.  
Key Pattern: `[^#/\s]+`   
Value Length Constraints: Minimum length of 1. Maximum length of 50.  
Value Pattern: `\S+`   
Required: No

 ** [versions](#API_DisposePackageVersions_RequestSyntax) **   <a name="codeartifact-DisposePackageVersions-request-versions"></a>
 The versions of the package you want to dispose.   
Type: Array of strings  
Array Members: Maximum number of 100 items.  
Length Constraints: Minimum length of 1. Maximum length of 255.  
Pattern: `[^#/\s]+`   
Required: Yes

## Response Syntax
<a name="API_DisposePackageVersions_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "failedVersions": { 
      "string" : { 
         "errorCode": "string",
         "errorMessage": "string"
      }
   },
   "successfulVersions": { 
      "string" : { 
         "revision": "string",
         "status": "string"
      }
   }
}
```

## Response Elements
<a name="API_DisposePackageVersions_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [failedVersions](#API_DisposePackageVersions_ResponseSyntax) **   <a name="codeartifact-DisposePackageVersions-response-failedVersions"></a>
 A `PackageVersionError` object that contains a map of errors codes for the disposed package versions that failed. The possible error codes are:   
+  `ALREADY_EXISTS` 
+  `MISMATCHED_REVISION` 
+  `MISMATCHED_STATUS` 
+  `NOT_ALLOWED` 
+  `NOT_FOUND` 
+  `SKIPPED` 
Type: String to [PackageVersionError](API_PackageVersionError.md) object map  
Key Length Constraints: Minimum length of 1. Maximum length of 255.  
Key Pattern: `[^#/\s]+` 

 ** [successfulVersions](#API_DisposePackageVersions_ResponseSyntax) **   <a name="codeartifact-DisposePackageVersions-response-successfulVersions"></a>
 A list of the package versions that were successfully disposed.   
Type: String to [SuccessfulPackageVersionInfo](API_SuccessfulPackageVersionInfo.md) object map  
Key Length Constraints: Minimum length of 1. Maximum length of 255.  
Key Pattern: `[^#/\s]+` 

## Errors
<a name="API_DisposePackageVersions_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
 The operation did not succeed because of an unauthorized access attempt.   
HTTP Status Code: 403

 ** ConflictException **   
 The operation did not succeed because prerequisites are not met.     
 ** resourceId **   
 The ID of the resource.   
 ** resourceType **   
 The type of AWS resource. 
HTTP Status Code: 409

 ** InternalServerException **   
 The operation did not succeed because of an error that occurred inside AWS CodeArtifact.   
HTTP Status Code: 500

 ** ResourceNotFoundException **   
 The operation did not succeed because the resource requested is not found in the service.     
 ** resourceId **   
 The ID of the resource.   
 ** resourceType **   
 The type of AWS resource. 
HTTP Status Code: 404

 ** ThrottlingException **   
 The operation did not succeed because too many requests are sent to the service.     
 ** retryAfterSeconds **   
 The time period, in seconds, to wait before retrying the request. 
HTTP Status Code: 429

 ** ValidationException **   
 The operation did not succeed because a parameter in the request was sent with an invalid value.     
 ** reason **   
 
HTTP Status Code: 400

## See Also
<a name="API_DisposePackageVersions_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/codeartifact-2018-09-22/DisposePackageVersions) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/codeartifact-2018-09-22/DisposePackageVersions) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/codeartifact-2018-09-22/DisposePackageVersions) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/codeartifact-2018-09-22/DisposePackageVersions) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/codeartifact-2018-09-22/DisposePackageVersions) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/codeartifact-2018-09-22/DisposePackageVersions) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/codeartifact-2018-09-22/DisposePackageVersions) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/codeartifact-2018-09-22/DisposePackageVersions) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/codeartifact-2018-09-22/DisposePackageVersions) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/codeartifact-2018-09-22/DisposePackageVersions) 